﻿var mapObject = {};

if (cz.aimtec.dci.utils.isMES()) {
    mapObject = {
        "jquery": "jquery.mes",
        "jquery-new": "jquery.mes",
        "jquery.revert-version": "jquery.mes"
    };
}

require.config({
	// Ensure the JS scripts reload correctly with new version of DCI
	urlArgs: "v=" + cz.aimtec.dci.utils.getCurrentVersion(),
	
    baseUrl: cz.aimtec.dci.utils.getBasePath(),
    paths: {
        'jquery': 'tools/jQuery/jquery-1.7.2.dci.min', 
        'jquery-new': 'tools/jQuery/jquery-1.10.2.min',
        'jquery-ui': 'tools/jQuery/jquery-ui-1.10.3.custom.min',
        'jquery.revert-version' : 'tools/jQuery/jquery.revert-version',
        'jquery.mes' : 'tools/jQuery/jquery.mes',
        'jquery.multiselect' : 'tools/jQuery/external/jquery.multiselect/jquery.multiselect.min',
        'jquery.form' : 'tools/jQuery/jquery.form.min',
        'jquery.ui.statusbar' : 'tools/jQuery/external/jquery.ui.statusbar',
        'jquery.quicksearch' : 'tools/jQuery/external/jquery.quicksearch',
        'jquery-3': 'webjars/jquery/3.3.1/jquery.min',

        // monaco editor
        'monaco-editor': 'webjars/monaco-editor/0.29.0/min/vs/loader',

        //fabric.js
        'fabric' : 'tools/fabricjs/fabric.min',
        
        // Menu Roles tree component
        'jstree': 'tools/jsTree/jstree.min',
        
        // fancytree
        'fancytree': 'tools/fancytree/jquery.fancytree.min',
        'fancytree.ui-deps': 'tools/fancytree/jquery.fancytree.ui-deps',
        'cz.aimtec.dci.jmesa.fancytree' : 'script/cz.aimtec.dci.jmesa.fancytree',
        'cz.aimtec.dci.jmesa.fancytree.opc' : 'script/cz.aimtec.dci.jmesa.fancytree.opc',
        
        // jMesa
        'jmesa' : 'tools/jMesa/jmesa.min-3.0.4',
        'jquery.jmesa.dci' : 'tools/jMesa/jquery.jmesa-3.0.4.dci',
        'jquery.validate' : 'tools/jQuery/external/validation/jquery.validate-1.9.0',
        'cz.aimtec.dci.jmesa.validators' : 'script/cz.aimtec.dci.jmesa.validators',
        'cz.aimtec.dci.jmesa.input' : 'script/cz.aimtec.dci.jmesa.input',
        'cz.aimtec.dci.jmesa' : 'script/cz.aimtec.dci.jmesa',
        'cz.aimtec.dci.jmesa.aggregation' : 'script/cz.aimtec.dci.jmesa.aggregation',
        'cz.aimtec.dci.collectionSettings' : 'script/cz.aimtec.dci.collectionSettings',
        'cz.aimtec.dci.displaytag.export': 'script/cz.aimtec.dci.displaytag.export',
        'cz.aimtec.dci.displaytag.filter': 'script/cz.aimtec.dci.displaytag.filter',
        'cz.aimtec.dci.displaytag.multiSelect': 'script/cz.aimtec.dci.displaytag.multiSelect',
        'cz.aimtec.dci.jmesa.tabs' : 'script/cz.aimtec.dci.jmesa.tabs',
        'cz.aimtec.dci.jmesa.multilineEdit' : 'script/cz.aimtec.dci.jmesa.multilineEdit',
        'cz.aimtec.dci.jmesa.multilineEdit.formater' : 'script/cz.aimtec.dci.jmesa.multilineEdit.formater',
        'cz.aimtec.dci.jmesa.codeEditor' : 'script/cz.aimtec.dci.jmesa.codeEditor',
        
        // jMesa Charts
        'echarts' : 'tools/echarts/echarts',
        
        // DHTMLx Scheduler
        'cz.aimtec.dci.scheduler' : 'script/cz.aimtec.dci.scheduler',
        'cz.aimtec.dci.scheduler.multiselect' : 'script/cz.aimtec.dci.scheduler.multiselect',
        'dhtmlxscheduler' : 'tools/dhtmlx/scheduler_v4325_pro/codebase/dhtmlxscheduler',
        'dhtmlxscheduler_limit' : 'tools/dhtmlx/scheduler_v4325_pro/codebase/ext/dhtmlxscheduler_limit',
        'dhtmlxscheduler_timeline' : 'tools/dhtmlx/scheduler_v4325_pro/codebase/ext/dhtmlxscheduler_timeline',
        'dhtmlxscheduler_treetimeline' : 'tools/dhtmlx/scheduler_v4325_pro/codebase/ext/dhtmlxscheduler_treetimeline',
        'dhtmlxscheduler_tooltip' : 'tools/dhtmlx/scheduler_v4325_pro/codebase/ext/dhtmlxscheduler_tooltip',
        'dhtmlxscheduler_minical' : 'tools/dhtmlx/scheduler_v4325_pro/codebase/ext/dhtmlxscheduler_minical',
        
        // DHTMLx locales
        'dhtmlxscheduler_locale_cs' : 'tools/dhtmlx/scheduler_v4325_pro/codebase/locale/locale_cs',
        'dhtmlxscheduler_locale_de' : 'tools/dhtmlx/scheduler_v4325_pro/codebase/locale/locale_de',
        'dhtmlxscheduler_locale_en' : 'tools/dhtmlx/scheduler_v4325_pro/codebase/locale/locale_en',
        'dhtmlxscheduler_locale_es' : 'tools/dhtmlx/scheduler_v4325_pro/codebase/locale/locale_es',
        'dhtmlxscheduler_locale_fr' : 'tools/dhtmlx/scheduler_v4325_pro/codebase/locale/locale_fr',
        'dhtmlxscheduler_locale_hu' : 'tools/dhtmlx/scheduler_v4325_pro/codebase/locale/locale_hu',
        'dhtmlxscheduler_locale_nl' : 'tools/dhtmlx/scheduler_v4325_pro/codebase/locale/locale_nl',
        'dhtmlxscheduler_locale_pl' : 'tools/dhtmlx/scheduler_v4325_pro/codebase/locale/locale_pl',
        'dhtmlxscheduler_locale_ro' : 'tools/dhtmlx/scheduler_v4325_pro/codebase/locale/locale_ro',
        'dhtmlxscheduler_locale_ru' : 'tools/dhtmlx/scheduler_v4325_pro/codebase/locale/locale_ru',
        'dhtmlxscheduler_locale_sk' : 'tools/dhtmlx/scheduler_v4325_pro/codebase/locale/locale_sk',
        'dhtmlxscheduler_locale_uk' : 'tools/dhtmlx/scheduler_v4325_pro/codebase/locale/locale_uk',
        'dhtmlxscheduler_locale_zh' : 'tools/dhtmlx/scheduler_v4325_pro/codebase/locale/locale_cn',
        
        // not translated
        'dhtmlxscheduler_locale_bg' : 'tools/dhtmlx/scheduler_v4325_pro/codebase/locale/locale_en',
        'dhtmlxscheduler_locale_mn' : 'tools/dhtmlx/scheduler_v4325_pro/codebase/locale/locale_en',
        
        'scheduler_api' : 'https://export.dhtmlx.com/scheduler/api',
        
        // W3Aria
        'w3aria_utils' : 'tools/w3-aria/utils',
        'w3aria_listbox' : 'tools/w3-aria/listbox/listbox',

        // JSNLOG modules
        'jslog' : 'tools/jsLog/jsnlog.min',

        // Number formatter library
        'number_formatter' : 'tools/number_formatter/format.min',

        // Context menu library
        'contextMenu' : 'tools/contextMenu/context.min',

        // DCIx JS Modules
        'cz.aimtec.dci.menu.autocomplete' : 'script/cz.aimtec.dci.menu.autocomplete',
        'cz.aimtec.dci.menuItemsForRole': 'script/cz.aimtec.dci.menuItemsForRole',
        'cz.aimtec.dci.menu.image.reports.refreshPage' : 'script/cz.aimtec.dci.menu.image.reports.refreshPage',
        'cz.aimtec.dci.chart' : 'script/cz.aimtec.dci.chart.echarts',
        'cz.aimtec.dci.chart.gantt' : 'script/cz.aimtec.dci.chart.echarts.gantt',
        'cz.aimtec.dci.chart.graph' : 'script/cz.aimtec.dci.chart.echarts.graph',
        'cz.aimtec.dci.roles' : 'script/cz.aimtec.dci.roles',
        'cz.aimtec.dci.emailNotifications': 'script/cz.aimtec.dci.emailNotifications',
        'cz.aimtec.dci.displaytag.refDetail' : 'script/cz.aimtec.dci.displaytag.refDetail',
        'cz.aimtec.dci.transaction.xp.initializeMultiselect' : 'script/cz.aimtec.dci.transaction.xp.initializeMultiselect',
        'cz.aimtec.dci.partAdditionValuesColl' : 'script/cz.aimtec.dci.partAdditionValuesColl',
        'cz.aimtec.dci.displaytag' : 'script/cz.aimtec.dci.displaytag',
        'cz.aimtec.dci.editArea' : 'script/cz.aimtec.dci.editArea',
        'cz.aimtec.dci.transaction.xp' : 'script/cz.aimtec.dci.transaction.xp',
        'cz.aimtec.dci.transaction.xp.compare' : 'script/cz.aimtec.dci.transaction.xp.compare',
        'cz.aimtec.dci.transaction.xp.parameters' : 'script/cz.aimtec.dci.transaction.xp.parameters',
        'cz.aimtec.dci.transaction.xp.modules' : 'script/cz.aimtec.dci.transaction.xp.modules',
        'cz.aimtec.dci.transaction.xp.modules.arrayModulesToString' : 'script/cz.aimtec.dci.transaction.xp.modules.arrayModulesToString',
        'cz.aimtec.dci.transaction.xp.showSelectableDisplaytag' : 'script/cz.aimtec.dci.transaction.xp.showSelectableDisplaytag',
        'cz.aimtec.dci.transaction.xp.searchInDefinition' : 'script/cz.aimtec.dci.transaction.xp.searchInDefinition',
        'cz.aimtec.dci.transaction.xp.storeAttributesFromOrder' : 'script/cz.aimtec.dci.transaction.xp.storeAttributesFromOrder',
        'cz.aimtec.dci.transaction.xp.releaseComments' : 'script/cz.aimtec.dci.transaction.xp.releaseComments',
    	'cz.aimtec.dci.changePassword' : 'script/cz.aimtec.dci.changePassword',
		'cz.aimtec.dci.editUser' : 'script/cz.aimtec.dci.editUser',
		'cz.aimtec.dci.internetExplorerConfigDownload' : 'script/cz.aimtec.dci.internetExplorerConfigDownload',
		'cz.aimtec.dci.order.hierarchy' : 'script/cz.aimtec.dci.order.hierarchy',
		'cz.aimtec.dci.transaction.xp.scanBuffer' : 'script/cz.aimtec.dci.transaction.xp.scanBuffer',
		'cz.aimtec.dci.order.templOrderForDoctype' : 'script/cz.aimtec.dci.order.templOrderForDoctype',
        'cz.aimtec.dci.warehouse.stocktaking' : 'script/cz.aimtec.dci.warehouse.stocktaking',
        'cz.aimtec.dci.filePreview': 'script/cz.aimtec.dci.filePreview',
        'cz.aimtec.dci.fileBrowser': 'script/cz.aimtec.dci.fileBrowser',
        'cz.aimtec.dci.transaction.xp.selectPictureValue' : 'script/cz.aimtec.dci.transaction.xp.selectPictureValue',
        'cz.aimtec.dci.transaction.xp.showDocument' : 'script/cz.aimtec.dci.transaction.xp.showDocument',
        'cz.aimtec.dci.transaction.xp.mes.showDocument' : 'script/cz.aimtec.dci.transaction.xp.mes.showDocument',
        'cz.aimtec.dci.selectValue' : 'script/cz.aimtec.dci.selectValue',
        'cz.aimtec.dci.transactions.xp' : 'script/cz.aimtec.dci.transactions.xp',
        'cz.aimtec.dci.transactions.xp.field.reasonCode' : 'script/cz.aimtec.dci.transactions.xp.field.reasonCode',
       	'cz.aimtec.dci.message.indicator' : 'script/cz.aimtec.dci.message.indicator',
       	'cz.aimtec.dci.typingPage' : 'script/cz.aimtec.dci.typingPage',
       	'cz.aimtec.dci.ui.combobox' : 'script/cz.aimtec.dci.ui.combobox',
       	'cz.aimtec.dci.optimalPlanStrategy' : 'script/cz.aimtec.dci.optimalPlanStrategy',
       	'cz.aimtec.dci.transaction.optimalPlanStrategies' : 'script/cz.aimtec.dci.transaction.optimalPlanStrategies',
        'cz.aimtec.dci.transaction.xp.groupModules' : 'script/cz.aimtec.dci.transaction.xp.groupModules',
        'cz.aimtec.dci.showXML' : 'script/cz.aimtec.dci.showXML',
       	'cz.aimtec.dci.logger' : 'script/cz.aimtec.dci.logger',
       	'cz.aimtec.dci.orders' : 'script/cz.aimtec.dci.orders',
    	'cz.aimtec.dci.transaction.xp.modules.semaphore' : 'script/cz.aimtec.dci.transaction.xp.modules.semaphore',
        'cz.aimtec.dci.transaction.xp.modules.sendMessageToListenerType' : 'script/cz.aimtec.dci.transaction.xp.modules.sendMessageToListenerType',
    	'cz.aimtec.dci.websocket' : 'script/cz.aimtec.dci.websocket',
    	'cz.aimtec.dci.transaction.xp.fillQualityDocument' : 'script/cz.aimtec.dci.transaction.xp.fillQualityDocument',
    	'cz.aimtec.dci.transaction.xp.mes.fillQualityDocument' : 'script/cz.aimtec.dci.transaction.xp.mes.fillQualityDocument',
    	'cz.aimtec.dci.transaction.xp.selectPictureValue.qualityDoc' : 'script/cz.aimtec.dci.transaction.xp.selectPictureValue.qualityDoc',
    	'cz.aimtec.dci.refreshMenu' : 'script/cz.aimtec.dci.refreshMenu',
    	'cz.aimtec.dci.windows.closeRefreshParent' : 'script/cz.aimtec.dci.windows.closeRefreshParent',
    	'cz.aimtec.dci.windows.refreshCurrentWindow' : 'script/cz.aimtec.dci.windows.refreshCurrentWindow',
       	'cz.aimtec.dci.company' : 'script/cz.aimtec.dci.company',
    	'cz.aimtec.dci.tabs' : 'script/cz.aimtec.dci.tabs',
    	'cz.aimtec.dci.order.definitions' : 'script/cz.aimtec.dci.order.definitions',
    	'cz.aimtec.dci.assigneeColl' : 'script/cz.aimtec.dci.assigneeColl',
    	'cz.aimtec.dci.window.modalWindow' : 'script/cz.aimtec.dci.window.modalWindow',
    	'cz.aimtec.dci.hotKeys' : 'script/cz.aimtec.dci.hotKeys',
        'cz.aimtec.dci.paging' : 'script/cz.aimtec.dci.paging',
    	'cz.aimtec.dci.mes.authentication' : 'script/cz.aimtec.dci.mes.authentication',
    	'cz.aimtec.dci.mes.keyboard' : 'script/cz.aimtec.dci.mes.keyboard',
    	'cz.aimtec.dci.mes.paging' : 'script/cz.aimtec.dci.mes.paging',
    	'cz.aimtec.dci.mes.selectButton' : 'script/cz.aimtec.dci.mes.selectButton',
    	'cz.aimtec.dci.mes.selectValue' : 'script/cz.aimtec.dci.mes.selectValue',
    	'cz.aimtec.dci.mes.tableUtils' : 'script/cz.aimtec.dci.mes.tableUtils',
    	'cz.aimtec.dci.mes.utils' : 'script/cz.aimtec.dci.mes.utils',
    	'cz.aimtec.dci.mes.timer' : 'script/cz.aimtec.dci.mes.timer',
    	'cz.aimtec.dci.assignQualityDocumentQuestions' : 'script/cz.aimtec.dci.assignQualityDocumentQuestions',
        'cz.aimtec.dci.window.notification' : 'script/cz.aimtec.dci.window.notification',
        'cz.aimtec.dci.compareButton' : 'script/cz.aimtec.dci.compareButton',
        'cz.aimtec.dci.transferButton' : 'script/cz.aimtec.dci.transferButton',
        'cz.aimtec.dci.transferPage' : 'script/cz.aimtec.dci.transferPage',
        'cz.aimtec.dci.admin' : 'script/cz.aimtec.dci.admin',
        'cz.aimtec.dci.inputs' : 'script/cz.aimtec.dci.inputs',
        'cz.aimtec.dci.export' : 'script/cz.aimtec.dci.export',
        'cz.aimtec.dci.edit.position' : 'script/cz.aimtec.dci.edit.position',
        'cz.aimtec.dci.edit.quality.rule' : 'script/cz.aimtec.dci.edit.quality.rule',
        'cz.aimtec.dci.product.uploadImage' : 'script/cz.aimtec.dci.product.uploadImage',
        'cz.aimtec.dci.productBatch' : 'script/cz.aimtec.dci.productBatch',
        'cz.aimtec.dci.eit' : 'script/cz.aimtec.dci.eit',
        'cz.aimtec.dci.universal.mail.notifier.setup' : 'script/cz.aimtec.dci.universal.mail.notifier.setup',
        'cz.aimtec.dci.transactions.focus' : 'script/cz.aimtec.dci.transactions.focus',
        'cz.aimtec.dci.transactions.focus.mes' : 'script/cz.aimtec.dci.transactions.focus.mes',
        'cz.aimtec.dci.transactions.keyboard.keys' : 'script/cz.aimtec.dci.transactions.keyboard.keys',
        'cz.aimtec.dci.transaction.xp.page' : 'script/cz.aimtec.dci.transaction.xp.page',
        'cz.aimtec.dci.transaction.xp.offerOrder' : 'script/cz.aimtec.dci.transaction.xp.offerOrder',
        'cz.aimtec.dci.file' : 'script/cz.aimtec.dci.file',
        'cz.aimtec.dci.transaction.xp.unsaved.changes' : 'script/cz.aimtec.dci.transaction.xp.unsaved.changes',
        'cz.aimtec.dci.transaction.xp.strategy' : 'script/cz.aimtec.dci.transaction.xp.strategy',
    	'cz.aimtec.dci.transaction.xp.drawing' : 'script/cz.aimtec.dci.transaction.xp.drawing',
    	'cz.aimtec.dci.copyQualityDocumentQuestions': 'script/cz.aimtec.dci.copyQualityDocumentQuestions',
        'cz.aimtec.dci.project' : 'script/cz.aimtec.dci.project',
        'cz.aimtec.dci.contextMenu' : 'script/cz.aimtec.dci.contextMenu',
    	'cz.aimtec.dci.ballancedProductionPlan' : 'script/cz.aimtec.dci.ballancedProductionPlan',
    	'cz.aimtec.dci.transaction.xp.filename' : 'script/cz.aimtec.dci.transaction.xp.filename',
    	'cz.aimtec.dci.transaction.xp.mes' : 'script/cz.aimtec.dci.transaction.xp.mes',
    	'cz.aimtec.dci.visualization.transaction.definition': 'script/cz.aimtec.dci.visualization.transaction.definition',
    	'cz.aimtec.dci.visualization.transaction.definition.builder': 'script/cz.aimtec.dci.visualization.transaction.definition.builder',
    	'cz.aimtec.dci.visualization.transaction.definition.shapes': 'script/cz.aimtec.dci.visualization.transaction.definition.shapes',
        'cz.aimtec.dci.userDefineValues' : 'script/cz.aimtec.dci.userDefineValues',
        'cz.aimtec.dci.workerShiftCalendar' : 'script/cz.aimtec.dci.workerShiftCalendar',
        'cz.aimtec.dci.cldrNumberFormat' : 'script/cz.aimtec.dci.cldrNumberFormat',
        'cz.aimtec.dci.logon' : 'script/cz.aimtec.dci.logon',
        'cz.aimtec.dci.web.utils' : 'script/cz.aimtec.dci.web.utils',
        'cz.aimtec.dci.appResources' : 'script/cz.aimtec.dci.appResources',
        'cz.aimtec.dci.mes' : 'script/cz.aimtec.dci.mes',
        'cz.aimtec.dci.addContract': 'script/cz.aimtec.dci.addContract',
        'cz.aimtec.dci.window.utils' : 'script/cz.aimtec.dci.window.utils',
        'cz.aimtec.dci.dialog' : 'script/cz.aimtec.dci.dialog',
        'cz.aimtec.dci.displaytag.input' : 'script/cz.aimtec.dci.displaytag.input',
        'cz.aimtec.dci.window' : 'script/cz.aimtec.dci.window',
        'cz.aimtec.dci.window.content' : 'script/cz.aimtec.dci.window.content',
        'cz.aimtec.dci.utils.dialog' : 'script/cz.aimtec.dci.utils.dialog',
        'cz.aimtec.dci.form' : 'script/cz.aimtec.dci.form',
        'cz.aimtec.dci.left.menu' : 'script/cz.aimtec.dci.left.menu',
        'cz.aimtec.dci.desktop' : 'script/cz.aimtec.dci.desktop',
        'cz.aimtec.dci.windows.close' : 'script/cz.aimtec.dci.windows.close',
        'cz.aimtec.dci.menu' : 'script/cz.aimtec.dci.menu',
        'cz.aimtec.dci.systemServices' : 'script/cz.aimtec.dci.systemServices'
    },
    
    map: {"*": mapObject},

	// Configure the dependencies and exports for older, traditional "browser globals" - 
	// scripts that do not use define() to declare the dependencies and set a module value.
    // Don't export '$' by 'jquery' - it will overwrite global $ and jQuery variables, can't be restored by $.noConflict
    shim: {
    	
        // dhtmlx scheduler
        'dhtmlxscheduler_limit' : ['dhtmlxscheduler'],
        'dhtmlxscheduler_timeline' : ['dhtmlxscheduler_limit'],
        'dhtmlxscheduler_treetimeline' : ['dhtmlxscheduler_timeline'],
        'dhtmlxscheduler_tooltip' : ['dhtmlxscheduler_treetimeline'],
        'dhtmlxscheduler_minical' : ['dhtmlxscheduler_tooltip'],
        
        'dhtmlxscheduler_locale_cs' : ['dhtmlxscheduler_minical'],
        'dhtmlxscheduler_locale_en' : ['dhtmlxscheduler_minical'],
        'dhtmlxscheduler_locale_pl' : ['dhtmlxscheduler_minical'],
        'dhtmlxscheduler_locale_de' : ['dhtmlxscheduler_minical'],
        'dhtmlxscheduler_locale_fr' : ['dhtmlxscheduler_minical'],
        
        'scheduler_api' : ['dhtmlxscheduler'],
        
        // W3Aria
        'w3aria_listbox' : ['w3aria_utils'],

        // jsTree component
        'jstree' : {
        	deps : ['jquery-new']
        },
        
        // new version of jquery must be loaded before jquery-ui
        'jquery-ui' : {
        	deps : ['jquery-new']
        },
        
        'jquery.revert-version' : {
        	deps : ['jquery-new', 'jquery-ui']
        },

        // Jmesa dependencies
        'jquery.validate' : {
        	deps : ['jquery.jmesa.dci']
        },
        
        'jquery.jmesa.dci' : {
        	deps : ['jmesa']
        },
        
        'cz.aimtec.dci.collectionSettings' : {
        	deps : ['jquery.quicksearch'] 
        },
        
        'jmesa' : {
        	deps : ['jstree', 'jquery.revert-version']
        },

        'jquery.quicksearch' : {
        	deps : ['jquery.revert-version']
        },
        
        'jquery.multiselect' : {
        	deps : ['jquery.revert-version']
        },
        
        'cz.aimtec.dci.transaction.xp' : {
        	deps : ['jquery.revert-version']
        }
    }
    
});
