<%@ page contentType="text/html;charset=UTF-8" %>
<%@ page language="java" %>

<%-- ********************** tag libraries references --%>
<%@ taglib uri="/WEB-INF/struts-bean.tld" prefix="bean" %>
<%@ taglib uri="/WEB-INF/struts-html.tld" prefix="html" %>
<%@ taglib uri="/WEB-INF/struts-template.tld" prefix="template" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>

<template:insert template="/template/doctype.jsp"/>

<html:html locale="true">
	
	<tr id="${event.code}_subscription" additional-properties-code="opcSubscriptions" style="display:none">
		<td>&nbsp;</td>
		<td colspan="100">
			<table style="width: 100%; cellspacing: 0; cellpadding: 2; border: 0">
				<thead>
					<tr>
						<td class="viewHeadDetail viewHead" style="text-align:center;">
							<bean:message key="admin.scheduler.event.subscription.checking"/>
							<html:img page="${event.subscriptionCheckingStateImage}" height="12" width="12"
									  titleKey="${event.subscriptionCheckingDescriptionKey}" />&nbsp;&nbsp;
						</td>
						<td class="viewHeadDetail viewHead"><bean:message key="admin.scheduler.event.subscription.nodeId"/></td>
						<td class="viewHeadDetail viewHead"><bean:message key="admin.scheduler.event.subscription.attributeId"/></td>
						<td class="viewHeadDetail viewHead"><bean:message key="admin.scheduler.event.subscription.transactionCode"/></td>
						<td class="viewHeadDetail viewHead"><bean:message key="admin.scheduler.event.subscription.subscriptionState"/></td>
						<td class="viewHeadDetail viewHead"><bean:message key="admin.scheduler.event.subscription.lastExecution"/></td>
						<td class="viewHeadDetail viewHead"><bean:message key="admin.scheduler.event.subscription.publishingInterval"/></td>
					</tr>
				</thead>
				<tbody>
					<c:forEach var="subscription" items="${event.opcSubscriptions}">
						<tr subscription-id="${subscription.subscriptionId}">
							<td class="viewItemDetail viewItem" attribute="subscription">&nbsp;</td>
							<td class="viewItemDetail viewItem" attribute="nodeId">
								<span title="${subscription.nodeId}">${subscription.nodeIdShort}</span>
							</td>
							<td class="viewItemDetail viewItem" attribute="attributeId">${subscription.attributeId}</td>
							<td class="viewItemDetail viewItem" attribute="transactionCode">${subscription.transactionCode}</td>
							<td class="viewItemDetail viewItem" attribute="subscribed" data-type="indicator"><img src="${subscription.subscribed}" alt="Subscribed" height="12" width="12"/></td>
							<td class="viewItemDetail viewItem" attribute="lastRunTime" data-type="date">${subscription.lastRunTime}</td>
							<td class="viewItemDetail viewItem" attribute="publishingInterval">${subscription.publishingInterval}</td>
						</tr>
					</c:forEach>
				</tbody>
			</table>
		</td>
	</tr>

</html:html>	