package cz.aimtec.dci.coreservices.listener.tcpip.opc;

import com.prosysopc.ua.client.Subscription;

/**
 * Client subscription.
 *
 * @author asel
 */
public class ClientSubscription {
    private OPCClient client;
    private Subscription subscriptionReference;
    private DefaultTransMonitoredDataItemListener subscriptionThread;
    private OPCNode opcNode;

    /**
     * @param client
     * @param subscriptionReference
     * @param subscriptionThread
     */
    public ClientSubscription(OPCClient client, Subscription subscriptionReference, DefaultTransMonitoredDataItemListener subscriptionThread, OPCNode opcNode) {
        this.client = client;
        this.subscriptionReference = subscriptionReference;
        this.subscriptionThread = subscriptionThread;
        this.opcNode = opcNode;
    }

    public OPCClient getClient() {
        return client;
    }

    public Subscription getSubscriptionReference() {
        return subscriptionReference;
    }

    public void setSubscriptionReference(Subscription subscriptionReference) {
        this.subscriptionReference = subscriptionReference;
    }

    public DefaultTransMonitoredDataItemListener getSubscriptionThread() {
        return subscriptionThread;
    }

    public void setSubscriptionThread(DefaultTransMonitoredDataItemListener subscriptionThread) {
        this.subscriptionThread = subscriptionThread;
    }

    public OPCNode getOpcNode() {
        return opcNode;
    }


}
